#include <ultra64.h>
#include "constants.h"
#include "types.h"

static struct mpstrings strings[] = {
	// MPCONFIG_TEMPLE
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_PISTOLS
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_FARSIGHT
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_DRUGGUN
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_SLAYER
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_CLOAKING
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_SLOWMO
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_NOSHIELD
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_BRIEFCASE
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_SKEDARKING
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_FLAGS
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_SIMULANTS
	{
		"",
		{
			"ل߀с 1\n",
			"ل߀с 2\n",
			"߀с 1\n",
			"߀с 2\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_AUTOMATICS
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_ROCKETS
	{
		"",
		{
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
			"\n",
		},
	},
	// MPCONFIG_CHALLENGE01
	{
		"ل߀сҀۀ̀π̈́с΂̄́Ҁـρʀ",
		{
			"˂ 1\n",
			" 1\n",
			"˂ 2\n",
			" 2\n",
			"˂ 3\n",
			" 3\n",
			"˂ 4\n",
			" 4\n",
		},
	},
	// MPCONFIG_CHALLENGE02
	{
		"ل߀сҀۀ̀π́ҀـρʀπˁŁ؁ƀ",
		{
			" 1\n",
			" 1\n",
			" 2\n",
			" 2\n",
			" 3\n",
			" 3\n",
			" 4\n",
			" 4\n",
		},
	},
	// MPCONFIG_CHALLENGE03
	{
		"ل߀сҀۀ̀π́ҀـρʀAR34Ł؁ƀ",
		{
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
			" 8\n",
		},
	},
	// MPCONFIG_CHALLENGE04
	{
		"߀сҀۀ̀π́҅ۂK7 Avenger",
		{
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
			" 8\n",
		},
	},
	// MPCONFIG_CHALLENGE05
	{
		"߀сҀۀ̀π̀ρ̀ـρʀłڀр",
		{
			"Հڀρ 1\n",
			"܀ 1\n",
			"܀ 2\n",
			"܀ 3\n",
			"܀ 4\n",
			"܀ 5\n",
			"܀ 6\n",
			"܀ 7\n",
		},
	},
	// MPCONFIG_CHALLENGE06
	{
		"Ѐ߀ʀۀ̀؂܁ւŁ̇́āۀ̀πӅ߀сƀ",
		{
			"Ղ 1\n",
			"Ղ 2\n",
			"Ղ 3\n",
			"Ղ 4\n",
			"Ղ 5\n",
			"Ղ 6\n",
			"Ղ 7\n",
			"Ղ 8\n",
		},
	},
	// MPCONFIG_CHALLENGE07
	{
		"ӄʀ߀сҀۀ̀πͅ́҂̄悃׃Ҁ",
		{
			"̀Ѐπ 1\n",
			"̀Ѐπ 2\n",
			"̀Ѐπ 3\n",
			"̀Ѐπ 4\n",
			"̀Ѐπ 5\n",
			"̀Ѐπ 6\n",
			"̀Ѐπ 7\n",
			"̀Ѐπ 8\n",
		},
	},
	// MPCONFIG_CHALLENGE08
	{
		"Ѐ߀ʀۀ́߁ҀЀ߀ʀۀ́҃ς",
		{
			"܀с 1\n",
			"܀с 2\n",
			"܀с 3\n",
			"܀с 4\n",
			"܀с 5\n",
			"܀с 6\n",
			"܀с 7\n",
			"܀с 8\n",
		},
	},
	// MPCONFIG_CHALLENGE09
	{
		"׃ـρʀłڀр̀ʁʁρ",
		{
			"π 1\n",
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
		},
	},
	// MPCONFIG_CHALLENGE10
	{
		"󃪀߀с̀ʀրπ߀πՁ߂҃",
		{
			" 1\n",
			"܀ʀ 1\n",
			" 2\n",
			"܀ʀ 2\n",
			" 3\n",
			"܀ʀ 3\n",
			" 4\n",
			"܀ʀ 4\n",
		},
	},
	// MPCONFIG_CHALLENGE11
	{
		"߀с́҅ۀ̀ʀρ̀πրсŁ؁ƀ",
		{
			"ρ 1\n",
			"ρ 2\n",
			"ρ 3\n",
			"ρ 4\n",
			"ρ 5\n",
			"ρ 6\n",
			"ρ 7\n",
			"ρ 8\n",
		},
	},
	// MPCONFIG_CHALLENGE12
	{
		"܀؁܀򂄀ۀ̀πـρʀƀ",
		{
			"̀Ѐπ 1\n",
			"̀Ѐπ 2\n",
			"̀Ѐπ 3\n",
			"̀Ѐπ 4\n",
			"̀Ѐπ 5\n",
			"̀Ѐπ 6\n",
			"̀Ѐπ 7\n",
			"̀Ѐπ 8\n",
		},
	},
	// MPCONFIG_CHALLENGE13
	{
		"󂃂׃ـρʀƀπրсŁ؁ƀ",
		{
			" 1\n",
			" 1\n",
			" 2\n",
			" 2\n",
			" 3\n",
			" 3\n",
			" 4\n",
			" 4\n",
		},
	},
	// MPCONFIG_CHALLENGE14
	{
		"ӀЀ܁р׀ׁЀ߀ʀۀ̀؂܀Ҁƀ",
		{
			" 1\n",
			" 1\n",
			" 2\n",
			"рʀ 1\n",
			" 3\n",
			" 2\n",
			" 4\n",
			"рʀ 2\n",
		},
	},
	// MPCONFIG_CHALLENGE15
	{
		"ʁ󁉁܀߂Ѐ߀ʀۀ̀؂܀Ҁƀ",
		{
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
			" 8\n",
		},
	},
	// MPCONFIG_CHALLENGE16
	{
		"ŁҀـρʀ݀πڂŁ؁ƀ",
		{
			"р 1\n",
			"р 2\n",
			"р 3\n",
			"р 4\n",
			"р 5\n",
			"р 6\n",
			"р 7\n",
			"р 8\n",
		},
	},
	// MPCONFIG_CHALLENGE17
	{
		"Հ˄ā、̀Ѐ΀ڀрŁ؁ƀ",
		{
			"Ӏ 1\n",
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
		},
	},
	// MPCONFIG_CHALLENGE18
	{
		"߀߀сҀۀ̀πŁ؁ƀ",
		{
			"Ӏ 1\n",
			"рЀ 1\n",
			"рЀ 2\n",
			"рЀ 3\n",
			"рЀ 4\n",
			"рЀ 5\n",
			"рЀ 6\n",
			"рЀ 7\n",
		},
	},
	// MPCONFIG_CHALLENGE19
	{
		"ނāɀـρʀπˀłڀр",
		{
			"Հڀρ 1\n",
			"π 1\n",
			"܀с 1\n",
			"܀с 2\n",
			"܀с 3\n",
			"܀с 4\n",
			"܀с 5\n",
			"܀с 6\n",
		},
	},
	// MPCONFIG_CHALLENGE20
	{
		"׃ـρʀԁ҅ۀ̀πへс΁؁ǁ",
		{
			"рʀ 1\n",
			"рʀ 2\n",
			" 6\n",
			" 5\n",
			" 4\n",
			" 3\n",
			" 2\n",
			" 1\n",
		},
	},
	// MPCONFIG_CHALLENGE21
	{
		"߀πՁ̀ʀրπ܁р׀ׁ⃈ƀ",
		{
			"̀Ѐπ 1\n",
			"Ѐ܀ 1\n",
			"Ѐ܀ 2\n",
			"Ѐ܀ 3\n",
			"Ѐ܀ 4\n",
			"Ѐ܀ 5\n",
			"Ѐ܀ 6\n",
			"Ѐ܀ 7\n",
		},
	},
	// MPCONFIG_CHALLENGE22
	{
		"Ѐ߀ʀۀ̀؂܀׃󁒀рр̀׀܁ҁ",
		{
			"ƃǃ 1\n",
			"ƃǃȀ 1\n",
			"ƃǃȀ 2\n",
			"ƃǃȀ 3\n",
			"ƃǃȀ 4\n",
			"ƃǃȀ 5\n",
			"ƃǃȀ 6\n",
			"ƃǃȀ 7\n",
		},
	},
	// MPCONFIG_CHALLENGE23
	{
		"܀򂄀ۀ̀ρҀـρʀRC-P120Ł؁ƀ",
		{
			"׀ 1\n",
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
		},
	},
	// MPCONFIG_CHALLENGE24
	{
		"Ѐ߀ʀۀ̀؂܀Ԁπ",
		{
			" 1\n",
			" 1\n",
			"рʀ 1\n",
			" 2\n",
			" 2\n",
			"рʀ 2\n",
			" 3\n",
			" 4\n",
		},
	},
	// MPCONFIG_CHALLENGE25
	{
		"߀߀сҀۀ̀π́Ҁـρʀ̀܁р׀ׁ",
		{
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
			" 7\n",
			" 8\n",
		},
	},
	// MPCONFIG_CHALLENGE26
	{
		"ۂŀ",
		{
			" 1\n",
			" 2\n",
			" 1\n",
			" 2\n",
			" 3\n",
			" 4\n",
			" 5\n",
			" 6\n",
		},
	},
	// MPCONFIG_CHALLENGE27
	{
		"̄ʀրπӂ߀߀сȁ䁴ɀӀր܁΀",
		{
			" 1\n",
			" 1\n",
			" 2\n",
			" 2\n",
			" 3\n",
			" 3\n",
			" 4\n",
			" 4\n",
		},
	},
	// MPCONFIG_CHALLENGE28
	{
		"Ѐ߀ʀۀ̀؂܀ۂŁӆ߀сҀӀր܁",
		{
			"ʀ 1\n",
			"ʀ 2\n",
			"ʀ 3\n",
			"ʀ 4\n",
			"ʀ 5\n",
			"ʀ 6\n",
			"ʀ 7\n",
			"ʀ 8\n",
		},
	},
	// MPCONFIG_CHALLENGE29
	{
		"ۂŁҀـρʀDY357̀ڀр׀ρ",
		{
			"Ղ 1\n",
			"Ղ 2\n",
			"܀ 1\n",
			"܀ 2\n",
			"܀ 3\n",
			"܀ 4\n",
			"܀ 5\n",
			"܀ 6\n",
		},
	},
	// MPCONFIG_CHALLENGE30
	{
		"܀̄ҁفӆ߀сҀӀ",
		{
			"ρ 1\n",
			"Հڀρ 1\n",
			"π 1\n",
			"ρ 2\n",
			"ρ 3\n",
			"̀Ѐπ 3\n",
			"̀Ѐπ 2\n",
			"̀Ѐπ 1\n",
		},
	},
};
